<?php

namespace App\Http\Controllers;

use App\Models\DiaPreferencia;
use Illuminate\Http\JsonResponse;
use Illuminate\Http\Request;

class DiaPreferenciaController extends Controller
{
    /**
     * Display a listing of the resource.
     */
    public function index(): JsonResponse
    {
        $items = DiaPreferencia::all();

        return response()->json([
            'success' => true,
            'data' => $items,
            'message' => 'Registros obtenidos correctamente',
        ], 200);
    }

    /**
     * Store a newly created resource in storage.
     */
    public function store(Request $request): JsonResponse
    {
        $payload = $request->only((new DiaPreferencia())->getFillable());
        $diaPreferencia = DiaPreferencia::create($payload);

        return response()->json([
            'success' => true,
            'data' => $diaPreferencia,
            'message' => 'Registro creado correctamente',
        ], 201);
    }

    /**
     * Display the specified resource.
     */
    public function show(DiaPreferencia $diaPreferencia): JsonResponse
    {
        return response()->json([
            'success' => true,
            'data' => $diaPreferencia,
            'message' => 'Registro obtenido correctamente',
        ], 200);
    }

    /**
     * Update the specified resource in storage.
     */
    public function update(Request $request, DiaPreferencia $diaPreferencia): JsonResponse
    {
        $payload = $request->only((new DiaPreferencia())->getFillable());
        $diaPreferencia->update($payload);

        return response()->json([
            'success' => true,
            'data' => $diaPreferencia,
            'message' => 'Registro actualizado correctamente',
        ], 200);
    }

    /**
     * Remove the specified resource from storage.
     */
    public function destroy(DiaPreferencia $diaPreferencia): JsonResponse
    {
        $diaPreferencia->delete();

        return response()->json([
            'success' => true,
            'message' => 'Registro eliminado correctamente',
        ], 200);
    }
}